// buttons

var _ButtonListener__ContainerId = "front";

var _ButtonListener__ButtonBackgroundPushed = "url(Images/Button2.png)";
var _ButtonListener__ButtonBackgroundReleased = "url(Images/Button1.png)";

var _ButtonListener__PopupForeground = "black";
var _ButtonListener__PopupBackground = "#bef";
var _ButtonListener__PopupBorder     = "#4c8 1px solid";
var _ButtonListener__PopupOffset     = { x: 24, y : 20};
var _ButtonListener__PopupOpacity    = 0.7;

function ButtonListener( element, target, popup ) {
    this.element = element;
    this.target = target;
    this.enabled   = true;

    this.mouseDown = _ButtonListener__mouseDown;
    this.mouseUp   = _ButtonListener__mouseUp;
    this.mouseOut  = _ButtonListener__mouseOut;

    this.isDown    = false;
    this.enable    = _ButtonListener__enable;


    var self = this;
    element.addEventListener( 'mousedown', function() { self.mouseDown(); }, true );
    element.addEventListener( 'mouseout', function() { self.mouseOut(); }, true );
    element.addEventListener( 'mouseup', function() { self.mouseUp(); }, true );

    /* Popup */
    this.showPopUp = _ButtonListener__showPopUp;
    this.hidePopUp = _ButtonListener__hidePopUp;
    if ( popup ) {
        var elem = document.createElement( "div" );
        var bstyle = document.defaultView.getComputedStyle( element );
        var x = parseInt( bstyle.getPropertyValue( "left" ) );
        var y = parseInt( bstyle.getPropertyValue( "top" ) );
        elem.style.position = "absolute";
        elem.style.left       = ( x + _ButtonListener__PopupOffset.x ) + "px";
        elem.style.top        = ( y + _ButtonListener__PopupOffset.y ) + "px";
        elem.style.background = _ButtonListener__PopupBackground;
        elem.style.color      = _ButtonListener__PopupForeground;
        elem.style.fontFamily = "Lucida Grande";
        elem.style.fontSize   = "10px";
        elem.style.padding    = "2px;";
        elem.style.border     = _ButtonListener__PopupBorder;
        elem.style.opacity    = _ButtonListener__PopupOpacity;
        elem.style.display    = "none";
        elem.style.zIndex     = "999";
        elem.appendChild( document.createTextNode( tr( popup ) ) );

        var front = document.getElementById( _ButtonListener__ContainerId );
        front.appendChild( elem );
        this.popup = elem;
        element.addEventListener( 'mouseover', function() { self.showPopUp(); } );
        element.addEventListener( 'mouseout', function() { self.hidePopUp(); } );
        element.addEventListener( 'mouseup', function() { self.hidePopUp(); } );
    } else {
        this.popup = null;
    }
    
}

function _ButtonListener__enable( flag ) {
    if ( flag == this.enabled ) return;
    this.enabled = flag;
    if ( flag ) {
        this.element.style.opacity = 1.0;
    } else {
        this.element.style.opacity = 0.5;
    }
}

function _ButtonListener__mouseDown( event ) {
    this.hidePopUp();
    if ( this.enabled == false ) return;
    this.element.style.background = _ButtonListener__ButtonBackgroundPushed;
    this.isDown = true;
}

function _ButtonListener__mouseUp( event ) {
    this.hidePopUp();
    if ( this.enabled == false || this.isDown == false ) return;
    this.element.style.background = _ButtonListener__ButtonBackgroundReleased;
    this.target( event );
}

function _ButtonListener__mouseOut( event ) {
    this.hidePopUp();
    this.isDown = false;
    if ( this.enabled == false ) return;
    this.element.style.background = _ButtonListener__ButtonBackgroundReleased;
}

function _ButtonListener__showPopUp( event ) {
    if ( this.popup ) {
        this.popup.style.display = "block";
    }
}

function _ButtonListener__hidePopUp( event ) {
    if ( this.popup ) {
        this.popup.style.display = "none";
    }
}

// function setButtonAction( element, targetFunc ) {
//     var listener = new ButtonListener( element, targetFunc );
//     return listener;
// }

